* -------------------------------
* 	LPS Example
*
* 	Execution Control 2
*
*	Language: MC68K-ASM1
*	Style: plain MC68000
* 	Version: Ref1-m68k
* -------------------------------

* Reference Plain MC68000 Solution 1

* if statement with logical OR in control expression

* Register Usage
; d1 (word): variable a
; d2 (word): variable b
	org	$2000

* assumes input values already in registers

;	f1 = a >= 4;
	cmp	#4,d1
	sge	d7

;	f2 = b > -3;
	cmp	#-3,d2
	sgt	d6

	
;	f1 = f1 || f2;
; f1 == true if and only if d6 or d7 are set to true
; since in MC68000, scc set the byte operand to -1 if the condition is true,
;	f1 == true if and only if d6 + d7 != 0
	add.b	d7,d6

;	if ( f1 == 1 ) goto if_True;
; no cmp/tst needed, the result of the add is automatically compared to 0
	bne	if_True

* case False
;		a -= 2;
	sub	#2,d1
;		b += 1;
	add	#1,d2
;		goto if_end;
	bra	if_end

* case True
if_True:
;		b += 4;
	add	#4,d2
if_end:


* output values are d1 and d2 (word)

	end

#include <stdio.h>

int a, b;

int main( void ) {

	scanf( "%d%d", &a, &b );

	_Bool f1, f2;
	
	f1 = a >= 4;
	f2 = b > -3;
	f1 = f1 || f2;
	if ( f1 == 1 ) goto if_True;

// case False
		a -= 2;
		b += 1;
		goto if_end;

// case True
if_True:
		b += 4;

if_end:
		
	printf( "%d %d\n", a, b );

	return 0; 
}

/*
	Test Cases

	Test 1
	input: 2 -5
	output: 0 -4

	Test 2
	input: 4 -6
	output: 4 -2

	Test 3
	input: 3 -2
	output: 3 2

	Test 4
	input: 4 -1
	output: 4 3
*/

