# -------------------------------
# 	LPS Example
#
# 	Execution Control 2
#
#	Language: MIPS32-MARS
#	Style: plain MIPS32
# 	Version: Ref1-mips
# -------------------------------

# Reference Plain MIPS32 Solution 1

# if statement with logical OR in control expression

# Register Usage
# s1: variable a
# s2: variable b
	.text

# assumes input values already in registers

#	f1 = a >= 4;
	sge	$t0,$s1,4

#	f2 = b > -3;
	sgt	$t1,$s2,-3
	
#	f1 = f1 || f2;
# f1 == true if and only if f1 + f2 > 0
	add	$t0,$t0,$t1

#	if ( f1 == 1 ) goto if_True;
	bgtz	$t0,if_True

# case False
#		a -= 2;
	sub	$s1,$s1,2
#		b += 1;
	add	$s2,$s2,1
#		goto if_end;
	j	if_end

# case True
if_True:
#		b += 4;
	add	$s2,$s2,4
if_end:

# output values are s1 and s2

# Reference Unstructured C Solution 1
						
# #include <stdio.h>
#
# int a, b;
#
# int main( void ) {
#
#	scanf( "%d%d", &a, &b );
#
#	_Bool f1, f2;
#	
#	f1 = a >= 4;
#	f2 = b > -3;
#	f1 = f1 || f2;
#	if ( f1 == 1 ) goto if_True;
#
# // case False
#		a -= 2;
#		b += 1;
#		goto if_end;
#
# // case True
# if_True:
#		b += 4;
#
# if_end:
#		
#	printf( "%d %d\n", a, b );
#
#	return 0; 
# }
#
# /*
#	Test Cases
#
#	Test 1
#	input: 2 -5
#	output: 0 -4
#
#	Test 2
#	input: 4 -6
#	output: 4 -2
#
#	Test 3
#	input: 3 -2
#	output: 3 2
#
#	Test 4
#	input: 4 -1
#	output: 4 3
# */
